error.h File Reference

wreport exceptions. More...

`#include <stdexcept>`
`#include <string>`

Go to the source code of this file.

## Data Structures

class | wreport::error
| Base class for DB-All.e exceptions. More...
class | wreport::error_alloc
| Reports that memory allocation has failed. More...
class | wreport::errors::StringBase< ERROR_CODE >
class | wreport::error_notfound
| Reports that a search-like function could not find what was requested. More...
class | wreport::error_type
| For functions handling data with multiple types, reports a mismatch between the type requested and the type found. More...
class | wreport::error_handles
| For functions working with handles, reports a problem with handling handles, such as impossibility to allocate a new one, or an invalid handle being passed to the function. More...
class | wreport::error_toolong
| Report an error with a buffer being to short for the data it needs to fit. More...
class | wreport::error_system
| Report a system error message. More...
class | wreport::error_consistency
| Report an error when a consistency check failed. More...
class | wreport::error_parse
| Report an error when parsing informations. More...
class | wreport::error_regexp
| Report an error while handling regular expressions. More...
class | wreport::error_unimplemented
| Reports that a feature is still not implemented. More...
class | wreport::error_domain
| Report that a parameter is outside the acceptable domain. More...

## Namespaces

namespace | wreport
| String functions.

## Macros

#define | WREPORT_THROWF_ATTRS(a, b)
| Tell the compiler that a function always throws and expects printf-style arguments.

## Enumerations

enum

wreport::ErrorCode {
wreport::WR_ERR_NONE = 0 , wreport::WR_ERR_NOTFOUND = 1 , wreport::WR_ERR_TYPE = 2 , wreport::WR_ERR_ALLOC = 3 ,
wreport::WR_ERR_ODBC = 4 , wreport::WR_ERR_HANDLES = 5 , wreport::WR_ERR_TOOLONG = 6 , wreport::WR_ERR_SYSTEM = 7 ,
wreport::WR_ERR_CONSISTENCY = 8 , wreport::WR_ERR_PARSE = 9 , wreport::WR_ERR_WRITE = 10 , wreport::WR_ERR_REGEX = 11 ,
wreport::WR_ERR_UNIMPLEMENTED = 12 , wreport::WR_ERR_DOMAIN = 13
}

| C-style error codes used by exceptions. More...

## Detailed Description

wreport exceptions.

All wreport exceptions are derived from wreport::error, which is in turn derived from std::exception.

All wreport exceptions also have an exception specific error code, which makes it easy to turn a caught exception into an errno-style error code, when providing C or Fortran bindings.

## Macro Definition Documentation

## WREPORT_THROWF_ATTRS

#define WREPORT_THROWF_ATTRS | ( |  | a,
|  |  | b )

Value:
__attribute__ ((noreturn, format(printf, a, b)))

Tell the compiler that a function always throws and expects printf-style arguments.

Referenced by wreport::buffers::CrexInput::parse_error(), wreport::bufr::Input::parse_error(), wreport::bufr::Input::parse_error(), wreport::bufr::Input::parse_error(), wreport::error_consistency::throwf(), wreport::error_domain::throwf(), wreport::error_handles::throwf(), wreport::error_notfound::throwf(), wreport::error_parse::throwf(), wreport::error_regexp::throwf(), wreport::error_system::throwf(), wreport::error_toolong::throwf(), wreport::error_type::throwf(), and wreport::error_unimplemented::throwf().